package com.unitesk.requality.core;

import com.unitesk.requality.core.attribute.Attribute;

public class AttributesRulesHolder {
  private TreeNode nodeToStore = null;
  public AttributesRulesHolder(TreeDB treeDB) {
    nodeToStore = treeDB.getRootNode();
    loadRules();
  }
  private AttributesVersioningRule avr;
  private RequiredAttributesRule rar;
  public AttributesVersioningRule getARule() {
    return avr;
  }
  public void setARule(AttributesVersioningRule avr) {
    this.avr = avr;
  }
  public void saveRules() {
    if (nodeToStore != null){ 
      AttributesVersioningRule.save(nodeToStore, avr);
      RequiredAttributesRule.save(nodeToStore, rar);
    }
  }
  public void loadRules() {
    if (nodeToStore != null){ 
      avr = AttributesVersioningRule.load(nodeToStore);
      rar = RequiredAttributesRule.load(nodeToStore);
    }
  }
  public boolean matchAChanges(String type, ChangesSet<Attribute> changes) {
    if(avr == null)
      return false;
    return avr.match(type, changes);
  }
  public boolean isVersioningEnabled() {
    return avr!=null;
  }
  public RequiredAttributesRule getRequiredAttrRule(){
    if(rar == null)
      rar = new RequiredAttributesRule();
    return rar;
  }
  public void setRequiredAttrRule(RequiredAttributesRule r){
    rar = r;
  }
}
