/*
 * Copyright 2015 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.unitesk.requality.core;

import java.util.List;
import com.unitesk.requality.core.attribute.Attribute;

public class DefaultTreeChangeListener extends TreeChangeListener {
  @Override
  public void created(TreeNode node) {}

  @Override
  public void changed(TreeNode node, ChangesSet<Attribute> what) {}

  @Override
  public void deleted(TreeNode node) {}

  @Override
  public void moved(TreeNode node, TreeNode oldParent, TreeNode newParent) {}

  @SuppressWarnings("unchecked")
  @Override
  public void changed(List<TreeNodeChangeEvent> changes) {
    for (TreeNodeChangeEvent ce : changes)
      switch (ce.getType()) {
        case CREATE:
          created(ce.getTreeNodeTarget(), (Boolean) ce.getArguments()[0]);
          break;
        case DELETE:
          {
            deleted(ce.getTreeNodeTarget(), (Boolean) ce.getArguments()[0], (Moment)ce.getArguments()[2]);
            break;
          }
        case CHANGE:
          changed(
              ce.getTreeNodeTarget(),
              (ChangesSet<Attribute>) ce.getArguments()[1],
              (Boolean) ce.getArguments()[0]);
          break;
        case MOVE:
          moved(
              ce.getTreeNodeTarget(),
              (TreeNode) ce.getArguments()[1],
              (TreeNode) ce.getArguments()[2],
              (Boolean) ce.getArguments()[0]);
          break;
        case CHILDREN_ORDER_CHANGE:
          childrenOrderChanged(
              ce.getTreeNodeTarget());
          break;
        default:
          break;
      }
  }

  @Override
  public void childrenOrderChanged(TreeNode node) {
    // TODO Auto-generated method stub
    
  }
}
