/**
 * ***************************************************************************** Institute for
 * System Programming of the Russian Academy of Sciences Copyright (c) 2009-2013 All rights
 * reserved. This program and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * ****************************************************************************
 */
package com.unitesk.requality.core;

// класс описывающий файл в "пространстве-времени" некоторого репозитория, то есть ревизия файла и его имя на момент ревизии
public class FileSpaceTimePoint {
  private String revision = "-1";
  private String path = "";
  private long secondsFromEpoch = 0;
  private String msg = "";
  private String author = null;

  public String getRevision() {
    return revision;
  }

  public String getPath() {
    return path;
  }

  public void setRevision(String rev) {
    revision = rev;
  }

  public void setPath(String pth) {
    path = pth;
  }

  public long getEpochTimeSec() {
    return secondsFromEpoch;
  }

  public void setEpochTimeSec(long eTime) {
    secondsFromEpoch = eTime;
  }

  public void setMessage(String Msg) {
    msg = Msg.replaceAll("[\n\r]", "<BR>");
  }

  public String getMessage() {
    return msg;
  }

  public void setAuthor(String athr) {
    if (athr == null || athr.isEmpty()) author = null;
    else author = athr.replaceAll("[\n\r]", "<BR>").replaceAll(":", "<COLON>");
  }

  public String getAuthor() {
    return author;
  }
}
