package com.unitesk.requality.core;

import java.io.IOException;
import java.net.URI;
import java.nio.file.Path;
import java.util.Map;
import com.unitesk.requality.report.Template;

public interface IResTracker {
  TreeDB[] getTreeDBs();

  TreeDB createProject(String name);

  void init(String... params);

  String getName(TreeDB db);

  TreeDB getTreeDB(String name);

  TreeDB trackTreeDB(URI path) throws  IOException;
  
  TreeDB trackTreeDB(URI path, String name) throws IOException;
  
  void remove(String name);

  String getLocation(TreeDB treeDB);

  Map<String, Template> getReportTemplates();

  void clearCache(TreeDB p);

  void trackProject(String name, TreeDB db);

  void reOpen(TreeDB treeDB);

  void initClasses(TreeDB db);

  Path getRootLocation();

  Path getGlobalCacheLocation();
}
