/*
 * Copyright 2015 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.unitesk.requality.core;

import java.util.Map;
import java.util.UUID;
import com.unitesk.requality.core.attribute.Attribute;
import com.unitesk.requality.core.attribute.AttributeDefinition;
import com.unitesk.requality.core.attribute.Version;

public interface IStorageDeltaListener {
  void beforeCreated(UUID uuid, UUID par, Map<String,AttributeDefinition> attributes, boolean internal);

  void created(UUID uuid, boolean forceInternal);

  void deleted(UUID uuid, Moment m, boolean forceInternal);
  //attrs are new on before stage and old on after
//  void changed(
//      UUID uuid, ChangesSet<Attribute> what, Map<String, AttributeDefinition> newa, Moment m, boolean forceInternal);

  void versionChanged(UUID uuid, ChangesSet<Version> changes, Moment m, boolean forceInternal);

  void resourceChanged(UUID uuid, String resName, Moment m, boolean forceInternal);

  void moved(UUID uuid, UUID oldParent, UUID newParent, Moment m, boolean forceInternal);

  void startChangeRow();

  void stopChangeRow();

  boolean changeAttributes(UUID uuid, ChangesSet<Attribute> what);
}
