package com.unitesk.requality.core;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import com.unitesk.requality.core.attribute.Attribute;
import com.unitesk.requality.core.attribute.AttributeDefinition;
import com.unitesk.requality.core.attribute.AttributeType;
import com.unitesk.requality.core.attribute.Flag;
import com.unitesk.requality.core.attribute.ListValue;
import com.unitesk.requality.core.attribute.SystemNames;
import com.unitesk.requality.core.attribute.valueproviders.ConstValueProvider;

public class RequiredAttributesRule {
  private static String ATTR_MAP = "_requiredAttrsMap";
  private Map<String, Map<String, AttributeDefinition>> map = new HashMap<>();
  public Map<String, Map<String, AttributeDefinition>> getMap(){
    return map;
  }
  public void setMap(Map<String, Map<String, AttributeDefinition>> mp){
    this.map = mp;
  }
  public static void save(TreeNode nodeToStore, RequiredAttributesRule rar){
    if(rar == null)
      nodeToStore.attrs().removeAttribute(ATTR_MAP);
    else{
      List<Object> lvs = new ArrayList<>();
      for(Entry<String, Map<String, AttributeDefinition>> en: rar.map.entrySet()){
        List<Object> lvs2 = new ArrayList<>();
        
        List<Object> lvs3 = new ArrayList<>();
        lvs3.add(en.getKey());
        lvs2.add(new ListValue(AttributeType.STRING, lvs3));//type
        
        for(Entry<String, AttributeDefinition> en2:en.getValue().entrySet()){
          AttributeDefinition ad = en2.getValue();
          lvs3 = new ArrayList<>();
          
          List<Object> lvs4 = new ArrayList<>();
          lvs4.add(en2.getKey());
          lvs3.add(new ListValue(AttributeType.STRING, lvs4));
          
          lvs4 = new ArrayList<>();
          lvs4.add(ad.getRawValue().getValue());
          lvs3.add(new ListValue(en2.getValue().getType(), lvs4));
          
          lvs2.add(new ListValue(AttributeType.LIST, lvs3));
        }
        lvs.add(new ListValue(AttributeType.LIST, lvs2));
      }
      ListValue lv = new ListValue(AttributeType.LIST, lvs);
      nodeToStore.attrs().setAttribute(
          new AttributeDefinition(nodeToStore.getUUId(), ATTR_MAP,
              new ConstValueProvider(AttributeType.LIST, lv), Flag.HIDDEN));
    }
    nodeToStore.commitAttributes();
  }
  public static RequiredAttributesRule load(TreeNode nodeToStore){
    Attribute a = nodeToStore.attrs().getAttribute(ATTR_MAP);
    Map<String, Map<String, AttributeDefinition>> map = new HashMap<>();
    if(a!=null){
      ListValue lv = a.getGValue();
      if(lv!=null){
        for(Object o: lv.getValues()){
          ListValue lvl2 = (ListValue)o;
          String type = ((ListValue)lvl2.getValues().get(0)).getValues().get(0).toString();
          if(!map.containsKey(type))
            map.put(type, new HashMap<>());
          for(int i = 1;i<lvl2.getValues().size();i++)
          {
            ListValue lvl3 = (ListValue) lvl2.getValues().get(i);
            ListValue keys = ((ListValue)lvl3.getValues().get(0));
            String key1 = keys.getValues().get(0).toString(),
                key2 = SystemNames.getVisSysName(key1);
            if(key2 == null)
              key2 = key1;
            ListValue lvl4 = (ListValue)lvl3.getValues().get(1);
            AttributeType at = lvl4.getType();
            Object val = lvl4.getValues().get(0);
            if(!map.get(type).containsKey(key1))
              map.get(type).put(key1, new AttributeDefinition(null, key2, 
                  new ConstValueProvider(at, val)));
          }
        }
      }
    }
    RequiredAttributesRule rar = new RequiredAttributesRule();
    rar.setMap(map);
    return rar;
  }
  public AttributeDefinition getDefinition(String type, String key) {
    if(!map.containsKey(type))
      return null;
    return map.get(type).get(key);
  }
}
