package com.unitesk.requality.core;

import java.util.HashMap;
import java.util.Map;

public class SortingSettings {
  public static enum SortingMethod {
    BY_NAMES,
    BY_LOCATIONS,
    BY_INDEX
  };

  private SortingMethod method;
  private boolean sep;
  private static Map<SortingMethod,Map<Boolean,SortingSettings>> map = new HashMap<>();

  public static SortingSettings init(SortingMethod m, boolean separate){
    if(!map.containsKey(m))
      map.put(m, new HashMap<>());
    if(!map.get(m).containsKey(separate))
      map.get(m).put(separate, new SortingSettings(m, separate));
    return map.get(m).get(separate);
  }
  private SortingSettings(SortingMethod m, boolean separate) {
    method = m;
    sep = separate;
  }

  public SortingMethod getMethod() {
    return method;
  }

  public boolean getSeparateByTypesFlag() {
    return sep;
  }

  @Override
  public boolean equals(Object obj) {
    return this == obj;
  }

  public static String getSortingName(SortingMethod sm) {
    switch (sm) {
      case BY_INDEX:
        return "By Index";
      case BY_LOCATIONS:
        return "By Locations";
      case BY_NAMES:
        return "By Names";
      default:
        break;
    }
    return "Unknown!";
  }
}
