package com.unitesk.requality.core;

import com.unitesk.requality.core.attribute.Attribute;

public abstract class TreeChangeListener implements ITreeChangeListener {

  @Override
  public void changed(
      TreeNode node, ChangesSet<Attribute> what, boolean internal) {
    changed(node, what);
  }

  @Override
  public void created(TreeNode node, boolean internal) {
    created(node);
  }

  @Override
  public void deleted(TreeNode node, boolean internal, Moment m) {
    if(m == Moment.AFTER)
      deleted(node);
  }

  @Override
  public void moved(TreeNode node, TreeNode oldParent, TreeNode newParent, boolean internal) {
    moved(node, oldParent, newParent);
  }

  public abstract void changed(TreeNode node, ChangesSet<Attribute> what);

  public abstract void created(TreeNode node);

  public abstract void deleted(TreeNode node);

  public abstract void moved(TreeNode node, TreeNode oldParent, TreeNode newParent);
}
