package com.unitesk.requality.core;

import java.util.UUID;
import com.unitesk.requality.core.instancer.Instantiator;

public class TreeNodeChangeEvent {
  public enum TreeNodeChangeEventType {
    CREATE,
    CHANGE,
    DELETE,
    MOVE,
    SETFOCUS,
    CACHE_CHANGE,
    CHILDREN_ORDER_CHANGE,
  }

  private TreeNodeChangeEventType type;
  private Object target;
  private Object[] args;

  public TreeNodeChangeEvent(TreeNodeChangeEventType tp, Object targ, Object... arg) {
    type = tp;
    target = targ;
    args = arg;
  }

  public TreeNodeChangeEventType getType() {
    return type;
  }

  public Object[] getArguments() {
    return args;
  }

  public NodeDesc getNodeDescArgument(int i) {
    if (i < 0 || i > args.length) return null;
    Object o = args[i];
    if (o instanceof NodeDesc) return (NodeDesc) o;
    return null;
  }

  public TreeNode getTreeNodeTarget() {
    TreeNode node = null;
    if (target instanceof TreeNode) node = (TreeNode) target;
    if (node != null
        && node.isVirtual()
        && !node.isDisposed()
        && node.getTreeDB() != null
        && !node.getTreeDB().isVirtual())
      try {
        UUID uid = node.getVRoot();
        if (uid != null)
          node = Instantiator.getExistVirtualTreeDB(node.getTreeDB(), uid).getNode(node.getUUId());
        else node = node.getTreeDB().getNode(node.getUUId());
        // node =
        // Instantiator.getVirtualTreeDB(node.getTreeDB(),Instantiator.DEFAULT_INSTANCE_NAME).getNode(node.getUUId());
      } catch (Exception e) {
      }
    return node;
  }

  public NodeDesc getNodeDescTarget() {
    if (target instanceof NodeDesc) return (NodeDesc) target;
    return null; // NodeDesc.fromNode((TreeNode)target);
  }

  @Override
  public String toString() {
    return type + " " + target.toString() + " " + args.length + " " + args;
  }
}
