package com.unitesk.requality.core.api;

import java.util.Collection;
import java.util.LinkedList;
import java.util.Map;
import com.unitesk.requality.core.descriptors.CoverageStorageSourceDescriptor;
import com.unitesk.requality.core.operations.mass.LibreOfficeAfterProcessing;
import com.unitesk.requality.core.operations.mass.MassIDRenames;
import com.unitesk.requality.core.operations.mass.MassKindFixer;
import com.unitesk.requality.core.operations.mass.MassLocationsFixer;
import com.unitesk.requality.core.operations.mass.MassRefFixer;
import com.unitesk.requality.core.operations.mass.MassReqTypeFixer;
import com.unitesk.requality.core.operations.mass.MassTNHeaderExplode;
import com.unitesk.requality.core.operations.mass.NodeSearch;
import com.unitesk.requality.core.operations.mass.NullTreeNodes;
import com.unitesk.requality.core.operations.mass.TermsHandler;
import com.unitesk.requality.report.Template;

public class DefaultAPISource implements IAPISource {
  @Override
  public Collection<MassOppDescriptor> loadMassOpsDescriptors() {
    return new LinkedList<MassOppDescriptor>() {
      /** */
      private static final long serialVersionUID = 8988349444956818013L;

      {
        {
          add(
              new MassOppDescriptor(
                  "com.requality.tnFix",
                  "Fix textnodes with req children",
                  new MassReqTypeFixer(),
                  true));
          add(
              new MassOppDescriptor(
                  "com.requality.locFix", "Fix locations", new MassLocationsFixer(), true));
          add(
              new MassOppDescriptor(
                  "com.requality.idRenames", "IDRenames", new MassIDRenames(), true));
          add(
              new MassOppDescriptor(
                  "com.requality.tNHeaderExplode",
                  "TNHeaderExplode",
                  new MassTNHeaderExplode(),
                  true));
          add(
              new MassOppDescriptor(
                  "com.requality.nullTreeNodes", "NullTreeNodes", new NullTreeNodes(), true));
          add(
              new MassOppDescriptor(
                  "com.requality.kindFixer", "Mass 'Вид' fixer", new MassKindFixer(), true));
          add(
              new MassOppDescriptor(
                  "com.requality.libreafterprocessing",
                  "After-import processing for libreoffice html documents",
                  new LibreOfficeAfterProcessing(),
                  false));
          add(
              new MassOppDescriptor(
                  "com.requality.termshandler",
                  "Terms handler",
                  new TermsHandler(),
                  false));
          
          add(
              new MassOppDescriptor(
                  "com.requality.refFixer", "Mass Reference fixer", new MassRefFixer(), true));
          add(
              new MassOppDescriptor(
                  "com.requality.searchNode", "Search Node", new NodeSearch(), true));//hidden for now
        }
      }
    };
  }

  @Override
  public Map<String, Template> getReportTemplates() {
    // TODO Auto-generated method stub
    return null;
  }

  @Override
  public Map<String, CoverageStorageSourceDescriptor> getCoverageSources() {
    // TODO Auto-generated method stub
    return null;
  }
}
