package com.unitesk.requality.core.api;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.jws.WebService;

import com.unitesk.requality.core.Path;
import com.unitesk.requality.core.ResManager;
import com.unitesk.requality.core.TreeDB;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.nodetypes.Requirement;
import com.unitesk.requality.tools.DeepFirstTreeWalker;

@WebService(endpointInterface = "com.unitesk.requality.core.api.RPCInterface") // this
// binds
// the
// SEI
// to
// the
// SIB
public class ReqService implements RPCInterface {
  ResManager tt;;

  public ReqService(ResManager tracker) {
    tt = tracker;
  }

  @Override
  public String[] getProjectNames() {
    String[] ret = new String[tt.getTreeDBs().length];
    int i = 0;
    for (TreeDB db : tt.getTreeDBs()) ret[i++] = db.getName();
    return ret;
  }

  @Override
  public String[] getIds(String proj) {
    for (TreeDB db : tt.getTreeDBs())
      if (db.getName().equals(proj)) {
        DeepFirstTreeWalker dftw =
            new DeepFirstTreeWalker(db.getNode(Requirement.getTypeRootQId(), Path.QID));
        Iterator<TreeNode> it = dftw.iterator();
        List<String> ids = new LinkedList<>();
        while (it.hasNext()) ids.add(it.next().getUserVisibleName(true));
        return ids.toArray(new String[0]);
      }
    return null;
  }

  @Override
  public boolean isCorrect(String proj, String id) {
    for (TreeDB db : tt.getTreeDBs())
      if (db.getName().equals(proj)) {
        return db.getNode(id, Path.QID | Path.UV | Path.XPATH) != null;
      }
    return false;
  }
}
