package com.unitesk.requality.core.attribute.valueproviders;

import java.util.Collections;
import java.util.Map;
import java.util.Set;
import org.json.JSONException;
import org.json.JSONObject;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.core.attribute.AttributeStorage;
import com.unitesk.requality.core.attribute.AttributeType;
import com.unitesk.requality.core.attribute.TypedValue;

public interface IValueProvider {
  static Set<String> NULLDEP = Collections.emptySet();
  TypedValue getTypedValue(String key, AttributeStorage as);
  Set<String> getDependencies(AttributeStorage as);
  String getType();
  //IValueProvider clone();
  TypedValue getRawValue();
  Map<String, Object> getRawStores();
  void attach(TreeNode node);
  void detach(TreeNode node);
  void saveJSON(JSONObject vpo) throws JSONException;
  AttributeType getAttributeType();
}
