package com.unitesk.requality.core.attribute.valueproviders;

import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import org.json.JSONException;
import org.json.JSONObject;
import com.unitesk.requality.core.TermsStorage;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.core.attribute.AttributeStorage;
import com.unitesk.requality.core.attribute.AttributeType;
import com.unitesk.requality.core.attribute.ListValue;
import com.unitesk.requality.core.attribute.TypedValue;

public class TermsValueProvider implements IValueProvider {
  public static String TYPE = "TermsProvider";
  private boolean direct;
  public TermsValueProvider(boolean b) {
    direct = b;
  }

  @Override
  public TypedValue getTypedValue(String key, AttributeStorage as) {
    TermsStorage ts = as.getNode().getTreeDB().getTermsStorage();
    List<Object> l1 = new LinkedList<>((direct?
        ts.getDirectTerms(as.getNode()):
          ts.getRevertTerms(as.getNode())).keySet());
    return new TypedValue(AttributeType.LIST, new ListValue(AttributeType.STRING,l1));
  }
  private static Set<String>depd, depr;
  static{
    depd = new HashSet<>();
    depd.add(TermsStorage.USE_TERM);
    depd.add(TermsStorage.USE_TERM_ALT);
    depr = new HashSet<>();
    depr.add(TermsStorage.DEF_TERM);
  }
  @Override
  public Set<String> getDependencies(AttributeStorage as) {
    return direct?depd:depr;
  }

  @Override
  public String getType() {
    return TYPE;
  }

  @Override
  public TypedValue getRawValue() {
    return null;
  }

  @Override
  public Map<String, Object> getRawStores() {
    return null;
  }

  private static TermsValueProvider d = new TermsValueProvider(true),
                                    r = new TermsValueProvider(false);
  public static IValueProvider getOne(boolean direct) {
    return direct?d:r;
  }

  @Override
  public void attach(TreeNode node) {
    // TODO Auto-generated method stub
    
  }

  @Override
  public void detach(TreeNode node) {
    // TODO Auto-generated method stub
    
  }

  @Override
  public void saveJSON(JSONObject vpo) throws JSONException {
    throw new UnsupportedOperationException();
  }

  @Override
  public AttributeType getAttributeType() {
    return AttributeType.LIST;
  }
}
