package com.unitesk.requality.core.checkers;

import com.unitesk.requality.core.TreeNode;

/** Class represents problems over Tree Nodes */
public class CheckerWarning implements IMark {
  private TreeNode target;
  private String description;

  public CheckerWarning(TreeNode target, String description) {
    this.target = target;
    this.description = description;
  }

  /*
   * (non-Javadoc)
   *
   * @see com.unitesk.requality.core.checkers.IMark#getDescription()
   */
  @Override
  public String getDescription() {
    return description;
  }

  /*
   * (non-Javadoc)
   *
   * @see com.unitesk.requality.core.checkers.IMark#getTarget()
   */
  @Override
  public Object getTarget() {
    return target;
  }

  @Override
  public String toString() {
    return target.toString() + ": " + description;
  }
}
