package com.unitesk.requality.core.checkers;

import java.util.List;
import java.util.Map;
import java.util.UUID;

import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.nodetypes.Document;

public class DocumentRefsChecker implements IChecker {
  public DocumentRefsChecker() {}

  @Override
  public boolean check(TreeNode node, List<IMark> result) {
    // null type is an error
    if (node.isDisposed()
        || node.getType() == null
        || (!node.getType().equals(Document.TYPE_NAME))) {
      return true;
    }
    // if(node.getType().equals(Document.TYPE_NAME)){
    //
    // Document d = (Document)node;
    // //TreeNode[]reqs = l.getWorkChildren();
    // for(UUID u:d.getLocations()){
    // TreeNode l = (TreeNode) node.getTreeDB().getNode(u);
    // if(l == null)
    // result.add(new CheckerProblem(l.getWorkParent(), "Location with UUID:
    // " + u
    // + " was missing"));
    // }
    //
    // }else
    if (node.getType().equals(Document.TYPE_NAME)) {

      Document d = (Document) node;
      Map<UUID, Integer> inds = d.getLocationIndexMap();
      if (inds == null) return true;
      for (UUID uid : inds.keySet()) {
        if (d.getTreeDB().getNode(uid) == null) {
          result.add(
              new CheckerProblem(
                  d, "Location in " + d.getQualifiedId() + " with Id: " + uid + " was missing"));
        }
      }
    }
    return true;
  }
}
