package com.unitesk.requality.core.domproxy;

import org.dom4j.QName;
import org.dom4j.tree.AbstractAttribute;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.core.attribute.Attribute;
import com.unitesk.requality.core.attribute.AttributeDefinition;
import com.unitesk.requality.core.attribute.AttributeType;
import com.unitesk.requality.core.attribute.valueproviders.ConstValueProvider;

public class RequalityAttribute extends AbstractAttribute {
  /** */
  private static final long serialVersionUID = 6175753875563830373L;

  private Attribute a;
  private TreeNode node;

  private RequalityAttribute(Attribute a, TreeNode node) {
    super();
    this.a = a;
    this.node = node;
  }

  public static RequalityAttribute getUUIDAttribute(TreeNode targ) {
    return RequalityAttribute.toAttribute(
        targ, new Attribute(
            new AttributeDefinition(targ.getUUId(), "uuid", 
                new ConstValueProvider(AttributeType.STRING, targ.getUUId().toString())), null));
  }

  public static RequalityAttribute getIdAttribute(TreeNode targ) {
    return RequalityAttribute.toAttribute(targ,
        new Attribute( 
            new AttributeDefinition(targ.getUUId(), "id", new ConstValueProvider(AttributeType.STRING, targ.getId())), null)
        //TODO remove?
        );
  }

  @Override
  public QName getQName() {
    return new QName(a.getKey());
  }

  public static RequalityAttribute toAttribute(TreeNode node, Attribute a) {
    if (a == null) return null;
    return new RequalityAttribute(a, node);
  }

  @Override
  public String getValue() {
    if (a.getValue() == null) return null;
    return a.getValue().toString();
  }

  public Attribute getWrappedAttribute() {
    return a;
  }

  public static RequalityAttribute getNameOrIdAttribute(TreeNode targ) {
    return RequalityAttribute.toAttribute(
        targ,
        new Attribute(
            new AttributeDefinition(targ.getUUId(), "nameorid",
                new ConstValueProvider(AttributeType.STRING,targ.getNameOrId())), null));
        //TODO remove?
//        targ.attrs().createAttribute("nameorid", targ.getNameOrId()));
  }
}
