package com.unitesk.requality.core.domproxy;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.UUID;
import org.dom4j.Attribute;
import org.dom4j.CDATA;
import org.dom4j.Comment;
import org.dom4j.Element;
import org.dom4j.Entity;
import org.dom4j.Namespace;
import org.dom4j.Node;
import org.dom4j.QName;
import org.dom4j.Text;
import com.unitesk.requality.core.TreeDB;
import com.unitesk.requality.core.TreeNode;

public class RequalityElement extends org.dom4j.tree.DefaultElement {
  /** */
  private static final long serialVersionUID = -8086379531810371502L;

  public TreeNode targ;

  @Override
  public void add(Node arg0) {}

  @Override
  public void add(Comment arg0) {}

  @Override
  public void add(Element arg0) {}

  @Override
  public Element addElement(String arg0) {
    return null;
  }

  @Override
  public Element addElement(QName arg0) {
    return null;
  }

  @Override
  public Element addElement(String arg0, String arg1) {
    return null;
  }

  @Override
  public void clearContent() {}

  public RequalityElement(TreeNode node) {
    super(node.getType());
    targ = node;
    setNamespace(Namespace.NO_NAMESPACE);
    setParent(toElement(node.getRoot().getUUId(), node.getWorkParent()));
    if (node.getWorkParent() != null)
      setDocument(toElement(node.getRoot().getUUId(), node.getWorkParent()).getDocument());
  }

  private static Map<TreeDB, Map<UUID, RequalityElement>> map =
      new HashMap<>();

  @Override
  public boolean matches(String patternText) {
    if (patternText.equals("/")) return targ.getTreeDB().getRootNode().equals(targ);
    return false;
  };

  @Override
  public boolean isRootElement() {
    return targ.equals(targ.getTreeDB().getRootNode());
  };

  public static RequalityElement toElement(UUID root, TreeNode node) {
    return toElement(root, node, false);
  }

  public static RequalityElement toElement(UUID root, TreeNode node, boolean force) {
    if (node == null) return null;
    if (!map.containsKey(node.getTreeDB()))
      map.put(node.getTreeDB(), new HashMap<UUID, RequalityElement>());
    if (!map.get(node.getTreeDB()).containsKey(node.getUUId()) || force)
      map.get(node.getTreeDB()).put(node.getUUId(), new RequalityElement(node));
    return map.get(node.getTreeDB()).get(node.getUUId());
  }

  public static List<RequalityElement> toElementList(TreeNode targ) {
    List<RequalityElement> l = new ArrayList<>();
    for (TreeNode node : targ.getWorkChildren()) l.add(toElement(node.getRoot().getUUId(), node));
    return l;
  }

  @Override
  public List<RequalityElement> content() {
    return toElementList(targ);
  }

  @Override
  public Element elementByID(String arg0) {
    TreeNode node = targ.findWorkChild(arg0);
    if (node != null) return toElement(node.getRoot().getUUId(), node);
    return null;
  }

  public TreeNode getWrappedTreeNode() {
    return targ;
  }

  @Override
  public int indexOf(Node arg0) {
    if (arg0 instanceof RequalityElement) {
      TreeNode[] nodes = targ.getSortedWorkChildren();
      for (int i = 0; i < nodes.length; i++) {
        TreeNode node = nodes[i];
        if (((RequalityElement) arg0).getWrappedTreeNode().equals(node)) return i;
      }
    }
    return -1;
  }

  @Override
  public Node node(int arg0) throws IndexOutOfBoundsException {
    if (arg0 > targ.sizeWorkChildren()) throw new IndexOutOfBoundsException();
    TreeNode node = targ.getWorkChildren()[arg0];
    return toElement(node.getRoot().getUUId(), node);
  }

  @Override
  public int nodeCount() {
    return targ.sizeWorkChildren();
  }

  @Override
  public Iterator<RequalityElement> nodeIterator() {
    final TreeNode[] nodes = targ.getWorkChildren();
    return new Iterator<RequalityElement>() {
      int i = 0;

      @Override
      public boolean hasNext() {
        return i < nodes.length;
      }

      @Override
      public RequalityElement next() {
        TreeNode node = nodes[i++];
        return toElement(node.getRoot().getUUId(), node);
      }

      @Override
      public void remove() {}
    };
  }

  @Override
  public boolean remove(Node arg0) {
    return false;
  }

  @Override
  public boolean remove(Comment arg0) {
    return false;
  }

  @Override
  public boolean remove(Element arg0) {
    return false;
  }

  @SuppressWarnings("rawtypes")
  @Override
  public void setContent(List arg0) {}

  @Override
  public Node detach() {
    return null;
  }

  @Override
  public String getName() {
    return targ.getType();
  }

  @Override
  public Element getParent() {
    TreeNode node = targ.getWorkParent();
    if (node != null && node.getRoot() != null) return toElement(node.getRoot().getUUId(), node);
    return null;
  }

  @Override
  public boolean hasContent() {
    return targ.sizeWorkChildren() > 0;
  }

  @Override
  public boolean isReadOnly() {
    return true;
  }

  @Override
  public void setName(String arg0) {}

  @Override
  public void setParent(Element arg0) {}

  @Override
  public void setText(String arg0) {}

  @Override
  public void add(Attribute arg0) {}

  @Override
  public void add(CDATA arg0) {}

  @Override
  public void add(Entity arg0) {}

  @Override
  public void add(Text arg0) {}

  @Override
  public Element addAttribute(String arg0, String arg1) {
    return null;
  }

  @Override
  public Element addAttribute(QName arg0, String arg1) {
    return null;
  }

  @Override
  public Element addCDATA(String arg0) {
    return null;
  }

  @Override
  public Element addComment(String arg0) {
    return null;
  }

  @Override
  public Element addEntity(String arg0, String arg1) {
    return null;
  }

  @Override
  public Element addProcessingInstruction(String arg0, String arg1) {
    return null;
  }

  @SuppressWarnings("rawtypes")
  @Override
  public Element addProcessingInstruction(String arg0, Map arg1) {
    return null;
  }

  @Override
  public Element addText(String arg0) {
    return null;
  }

  @Override
  public void appendAttributes(Element arg0) {}

  @Override
  public Attribute attribute(int arg0) {
    int i = arg0 - targ.attrs().getLocalAttributeKeys().size();
    if (i == 0) return RequalityAttribute.getUUIDAttribute(targ);
    if (i == 1) return RequalityAttribute.getIdAttribute(targ);
    if (i == 2) return RequalityAttribute.getIdAttribute(targ);
    return RequalityAttribute.toAttribute(
        targ, targ.attrs().toArray()[arg0]);
  }

  @Override
  public Attribute attribute(String arg0) {
    if (arg0.equals("uuid")) return RequalityAttribute.getUUIDAttribute(targ);
    if (arg0.equals("id")) return RequalityAttribute.getIdAttribute(targ);
    if (arg0.equals("nameorid")) return RequalityAttribute.getNameOrIdAttribute(targ);
    return RequalityAttribute.toAttribute(targ, targ.attrs().getAttribute(arg0));
  }

  @Override
  public Attribute attribute(QName arg0) {
    return attribute(arg0.getName());
  }

  @Override
  public int attributeCount() {
    return targ.attrs().getLocalAttributeKeys().size() + 3;//TODO check const 3 to be true
  }

  @Override
  public Iterator<RequalityAttribute> attributeIterator() {
    final Iterator<com.unitesk.requality.core.attribute.Attribute> attrs = targ.attrs().iterator();
    return new Iterator<RequalityAttribute>() {
      int cnt = 0;

      @Override
      public boolean hasNext() {
        if (attrs.hasNext()) return true;
        if (cnt > 2) return false;
        return true;
      }

      @Override
      public RequalityAttribute next() {
        if (attrs.hasNext()) return RequalityAttribute.toAttribute(targ, attrs.next());
        if (cnt++ == 0) return RequalityAttribute.getUUIDAttribute(targ);
        else if (cnt == 1) return RequalityAttribute.getIdAttribute(targ);
        else return RequalityAttribute.getNameOrIdAttribute(targ);
      }

      @Override
      public void remove() {}
    };
  }

  @Override
  public String attributeValue(String arg0) {
    return attribute(arg0).getValue();
  }

  @Override
  public String attributeValue(QName arg0) {
    return attribute(arg0).getValue();
  }

  @Override
  public String attributeValue(String arg0, String arg1) {
    Attribute ra = attribute(arg0);
    if (ra == null) return arg1;
    return ra.getValue();
  }

  @Override
  public String attributeValue(QName arg0, String arg1) {
    Attribute ra = attribute(arg0);
    if (ra == null) return arg1;
    return ra.getValue();
  }

  @Override
  public List<RequalityAttribute> attributes() {
    List<RequalityAttribute> l = new ArrayList<>();
    for (com.unitesk.requality.core.attribute.Attribute a : targ.attrs())
      l.add(RequalityAttribute.toAttribute(targ, a));
    return l;
  }

  @Override
  public Element createCopy() {
    return null;
  }

  @Override
  public Element createCopy(String arg0) {
    return null;
  }

  @Override
  public Element createCopy(QName arg0) {
    return null;
  }

  @Override
  public Element element(String arg0) {
    Iterator<RequalityElement> i = elementIterator(arg0);
    if (i.hasNext()) return i.next();
    return null;
  }

  @Override
  public Element element(QName arg0) {
    Iterator<RequalityElement> i = elementIterator(arg0);
    if (i.hasNext()) return i.next();
    return null;
  }

  @Override
  public Iterator<RequalityElement> elementIterator() {
    return nodeIterator();
  }

  @Override
  public Iterator<RequalityElement> elementIterator(String arg0) {
    final TreeNode[] list = targ.getSortedWorkChildren(arg0);
    return new Iterator<RequalityElement>() {
      int i = 0;

      @Override
      public boolean hasNext() {
        return i < list.length;
      }

      @Override
      public RequalityElement next() {
        TreeNode node = list[i++];
        return toElement(node.getRoot().getUUId(), node);
      }

      @Override
      public void remove() {}
    };
  }

  @Override
  public Iterator<RequalityElement> elementIterator(QName arg0) {
    final TreeNode[] list = targ.getSortedWorkChildren(arg0.getName());
    return new Iterator<RequalityElement>() {
      int i = 0;

      @Override
      public boolean hasNext() {
        return i < list.length;
      }

      @Override
      public RequalityElement next() {
        TreeNode node = list[i++];
        return toElement(node.getRoot().getUUId(), node);
      }

      @Override
      public void remove() {}
    };
  }

  @Override
  public List<RequalityElement> elements() {
    List<RequalityElement> l = new ArrayList<>();
    for (TreeNode node : targ.getSortedWorkChildren())
      l.add(toElement(node.getRoot().getUUId(), node));
    return l;
  }

  @Override
  public List<RequalityElement> elements(String arg0) {
    List<RequalityElement> l = new ArrayList<>();
    for (TreeNode node : targ.getSortedWorkChildren(arg0))
      l.add(toElement(node.getRoot().getUUId(), node));
    return l;
  }

  @Override
  public List<RequalityElement> elements(QName arg0) {
    return elements(arg0.getName());
  }

  @Override
  public Object getData() {
    return "";
  }

  @Override
  public String getText() {
    return "";
  }

  @Override
  public String getTextTrim() {
    return "";
  }

  @Override
  public boolean isTextOnly() {
    return false;
  }

  @Override
  public boolean remove(Attribute arg0) {
    return false;
  }

  @Override
  public boolean remove(CDATA arg0) {
    return false;
  }

  @Override
  public boolean remove(Entity arg0) {
    return false;
  }

  @Override
  public boolean remove(Namespace arg0) {
    return false;
  }

  @Override
  public boolean remove(Text arg0) {
    return false;
  }

  @Override
  public void setAttributeValue(String arg0, String arg1) {}

  @Override
  public void setAttributeValue(QName arg0, String arg1) {}

  @SuppressWarnings("rawtypes")
  @Override
  public void setAttributes(List arg0) {}

  @Override
  public void setData(Object arg0) {}

  @Override
  public void setQName(QName arg0) {}
}
