package com.unitesk.requality.core.operations;

import java.util.ArrayList;
import java.util.List;
import java.util.SortedMap;
import java.util.TreeMap;
import java.util.UUID;

import com.unitesk.requality.core.TreeDB;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.core.instancer.Instantiator;

public class CopyHandler {

  public Object execute(List<TreeNode> nodes) {
    copyNodes(nodes.toArray(new TreeNode[0]), false);
    return null;
  }

  public void copyNodes(TreeNode[] nodes, boolean cutNode) {
    if (nodes == null) return;
    TreeDB db = Instantiator.getRootTree(nodes[0].getTreeDB());
    for (TreeNode tn : nodes) {
      if (!Instantiator.getRootTree(tn.getTreeDB()).equals(db) || !db.getTreeLogic().isCopyable(tn))
        return;
    }
    List<TreeNode> workList = new ArrayList<>();
    SortedMap<UUID, String> quids = new TreeMap<>();
    for (TreeNode node : nodes) quids.put(node.getUUId(), node.getQualifiedId());
    for (TreeNode node : nodes) {
      boolean add = true;
      for (TreeNode n2 : nodes)
        if (n2 != node && quids.get(node.getUUId()).startsWith(quids.get(n2.getUUId()) + "/")) {
          add = false;
          break;
        }
      if (add) workList.add(node);
    }
    CopyPasteHelper.getInstance().setNodes(workList);
  }

  public boolean isEnabled(List<TreeNode> nodes) {
    if (nodes == null) {
      return false;
    }
    TreeDB db = Instantiator.getRootTree(nodes.get(0).getTreeDB());
    for (TreeNode tn : nodes) {
      if (!Instantiator.getRootTree(tn.getTreeDB()).equals(db) || !db.getTreeLogic().isCopyable(tn))
        return false;
    }
    return true;
  }
}
