package com.unitesk.requality.core.propagators;

import java.util.UUID;
import com.unitesk.requality.core.ChangesSet;
import com.unitesk.requality.core.Moment;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.core.attribute.Attribute;
import com.unitesk.requality.core.instancer.Instantiator;

public class ClonePropagator implements IAttributeChangePropagator {

  @Override
  public boolean shouldBeApplied(
      TreeNode node, ChangesSet<Attribute> cs, Moment m) {
    return !cs.isEmpty()&&m==Moment.AFTER;
  }

  @Override
  public boolean apply(TreeNode node, ChangesSet<Attribute> csa) {    
    for(UUID uid:Instantiator.getClones(node.getUUId(),node.getTreeDB())){
      ChangesSet<Attribute> cs = new ChangesSet<>(csa);
      
      if(node.getTreeDB().isLoaded(uid)){
        TreeNode clone = node.getTreeDB().getNode(uid);
        //TODO filter
        for(String k : csa.getOrder()){
          Attribute a = clone.attrs().getAttribute(k);
          if(a!=null && a.getOrigin().equals(uid))
            cs.removeKey(k);
        }
        node.getTreeDB().getDeltaTarget().changeAttributes(uid, cs);
        clone.commitAttributes();
      }
    }
    return true;
  }

  static IAttributeChangePropagator one = new ClonePropagator();
  public static IAttributeChangePropagator getOne() {
    return one;
  }

  @Override
  public int getPriority() {
    return 41;
  }
}
