package com.unitesk.requality.core.propagators;

import java.util.Map;
import java.util.Map.Entry;
import com.unitesk.requality.core.ChangesSet;
import com.unitesk.requality.core.Moment;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.core.attribute.Attribute;

public class ReferenceRevertPropagator implements IAttributeChangePropagator {

  @Override
  public int getPriority() {
    return 7;
  }

  @Override
  public boolean shouldBeApplied(
      TreeNode node,
      ChangesSet<Attribute> cs,
      Moment m) {
    if(m == Moment.AFTER)
      return false;
    Map<String,Attribute> newa = cs.getNewMap();
    for(Entry<String, Attribute> en:newa.entrySet())
    {
      Attribute old = cs.getOld(en.getKey());
      Attribute n = en.getValue();
      if(old!=null&&old.isReference()||n!=null&&n.isReference())
        return true;
    }
    return false;
  }

  @Override
  public boolean apply(
      TreeNode node,
      ChangesSet<Attribute> cs) {
    node.getTreeDB().getLinkResolver().handleAttrChanges(node, cs, true);
    return false;
  }
  static IAttributeChangePropagator one = new ReferenceRevertPropagator();
  public static IAttributeChangePropagator getOne() {
    return one;
  }
}
