package com.unitesk.requality.core.propagators;

import com.unitesk.requality.core.ChangesSet;
import com.unitesk.requality.core.Moment;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.core.attribute.Attribute;

public class UVIDPropagator implements IAttributeChangePropagator {
  
  TreeNode node;
  
  public UVIDPropagator(TreeNode n) {
    node = n;
  }
  
  @Override
  public boolean shouldBeApplied(
      TreeNode node, ChangesSet<Attribute> cs, Moment m) {
    return cs.getAll().contains(TreeNode.ATTR_USERVISIBLEID)&&m==Moment.AFTER;
  }

  @Override
  public boolean apply(TreeNode node, ChangesSet<Attribute> csa) {    
    this.node.attrs().updateAttribute(TreeNode.ATTR_USERVISIBLEID);
    this.node.commitAttributes();
    return true;
  }

  //static IAttributeChangePropagator one = new UVIDPropagator();
  public static IAttributeChangePropagator getOne(TreeNode node) {
    return new UVIDPropagator(node);
  }

  @Override
  public int getPriority() {
    return 41;
  }
}
