package com.unitesk.requality.core.propagators;

import com.unitesk.requality.core.ChangesSet;
import com.unitesk.requality.core.Moment;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.core.attribute.Attribute;
import com.unitesk.requality.nodetypes.VirtualNode;

public class VNodePropagator implements IAttributeChangePropagator {

  @Override
  public int getPriority() {
    return 40;
  }

  @Override
  public boolean shouldBeApplied(
      TreeNode node,
      ChangesSet<Attribute> cs,
      Moment m) {
    if(m==Moment.BEFORE)
      return false;
    if(node.getType().equals(VirtualNode.TYPE_NAME)&&cs.getAll().contains(VirtualNode.ATTR_COLLAPSEVNODE))
    {
      boolean state = ((VirtualNode)node).isCollapsed();
      Attribute ad = cs.getOld(VirtualNode.ATTR_COLLAPSEVNODE);
      boolean ostate = ad != null && ad.getValue()!=null && Boolean.parseBoolean(ad.getValue().toString());
      if(ostate != state)
        return true;
    }
    return false;
  }

  @Override
  public boolean apply(
      TreeNode node,
      ChangesSet<Attribute> cs) {
    node.getTreeDB().fireNodeChildrenOrderChange(node.getShownParent());
    return false;
  }
  
  static IAttributeChangePropagator one = new VNodePropagator();
  
  public static IAttributeChangePropagator getOne() {
    return one;
  }
}
