package com.unitesk.requality.core.search;

import java.util.Map;
import com.unitesk.requality.core.TreeDB;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.core.attribute.Attribute;
import com.unitesk.requality.core.attribute.TypedValue;

public class SearchRequest {
  private SearchMethod sm;
  private Map<String,TypedValue> params;
  public SearchRequest(SearchMethod sm, Map<String,TypedValue> params){
    this.sm = sm;
    this.params = params;
  }
  public SearchMethod getMethod(){
    return sm;
  }
  public String get(String string) {
    TypedValue tv = params.get(string);
    return tv == null ? null : tv.getGValue();
  }
  public boolean test(TreeNode node){
    if(node == null)
      return false;
    if(sm == SearchMethod.BY_PATH){
      TreeDB db = node.getTreeDB();
      TreeNode node2 = db.getNode(get("path"));
      if(node2 != null && node.getUUId().equals(node2.getUUId()))
        return true;
    }else
      if(sm == SearchMethod.BY_ATTRIBUTE){
        String key = params.get("key").getGValue();
        AttributeOperator op = AttributeOperator.valueOf(params.get("op").getGValue());
        Object toc = params.get("sample");
        if(toc!=null)
          toc = ((TypedValue)toc).getValue();
        Attribute a = node.attrs().getAttribute(key);
        if(op == AttributeOperator.EMPTY && 
            (a == null || a.getValue() == null || a.getValue().toString().isEmpty()))
          return true;
        if(op == AttributeOperator.NOT_EMPTY && 
            (a != null && a.getValue() != null && !a.getValue().toString().isEmpty()))
          return true;
        String aval = "";
        if(a!=null && a.getValue()!=null)
          aval = a.getValue().toString();
        
        String ra = "";
        if(toc!=null)
          ra = toc.toString();
        
        if(op == AttributeOperator.EQUALS)
          return ra.equals(aval);
        if(op == AttributeOperator.NOT_EQUALS)
          return !ra.equals(aval);
        if(op == AttributeOperator.CONTAINS)
          return aval.contains(ra);
        if(op == AttributeOperator.NOT_CONTAINS && a!=null && a.getValue()!=null)
          return !aval.contains(ra);
      }
    return false;
  }
  public static SearchRequest restore(Map<String, String> args) {
    // TODO Auto-generated method stub
    return null;
  }
}
