package com.unitesk.requality.core.transaction;

import java.util.HashMap;
import java.util.Map;
import java.util.UUID;
import com.unitesk.requality.core.CoreUtils;
import com.unitesk.requality.core.ITreeStorage;
import com.unitesk.requality.core.attribute.AttributeDefinition;

public class CreateNode extends TreeOperation {
  private UUID uuid;
  private UUID parentUUId;
  private String id;
  private Map<String, AttributeDefinition> attrs;

  public CreateNode(UUID parentUUId, UUID uuid, String id, Map<String, AttributeDefinition> attrs2) {
    this.parentUUId = parentUUId;
    this.uuid = uuid;
    this.id = id.trim();
    this.attrs = attrs2;
  }

  @Override
  public void apply(ITreeStorage storage) {
    if(CoreUtils.DEBUG_LEVEL>1)
      System.out.println("\t Apply create op "+uuid);
    storage.createNode(parentUUId, uuid, id, new HashMap<>(attrs));
  }

  @Override
  public void rollback(ITreeStorage storage) {
    if(CoreUtils.DEBUG_LEVEL>1)
      System.out.println("\t Revert create op "+uuid);
    storage.remove(uuid);
  }

  @Override
  public String toString() {
    return "Create " + id + "(" + uuid + ") on " + parentUUId + " [" + attrs.toString() + "]";
  }
}
