package com.unitesk.requality.core.transaction;

import java.util.HashMap;
import java.util.Map;
import java.util.UUID;
import com.unitesk.requality.core.CoreUtils;
import com.unitesk.requality.core.ITreeStorage;
import com.unitesk.requality.core.attribute.AttributeDefinition;

public class DeleteNode extends TreeOperation {
  private UUID parentUUId;
  UUID uuid;
  private String id;
  private Map<String, AttributeDefinition> attrs;

  public DeleteNode(UUID parentUUId, UUID uuid, String id, Map<String, AttributeDefinition> attrs) {
    this.parentUUId = parentUUId;
    this.uuid = uuid;
    this.id = id;
    this.attrs = attrs;
  }

  @Override
  public void apply(ITreeStorage storage) {
    if(CoreUtils.DEBUG_LEVEL>1)
      System.out.println("\t Apply delete op "+uuid);
    storage.remove(uuid);
  }

  @Override
  public void rollback(ITreeStorage storage) {
    if(CoreUtils.DEBUG_LEVEL>1)
      System.out.println("\t Revert delete op "+uuid);
    // if(parentUUId!=null)//TODo bug?
    storage.createNode(parentUUId, uuid, id, new HashMap<>(attrs));
  }

  @Override
  public String toString() {
    return "Remove " + uuid + " id:" + id + " par:" + parentUUId;
  }
}
