package com.unitesk.requality.core.transaction;

import java.util.UUID;

import com.unitesk.requality.core.ITreeStorage;

public class MoveNode extends TreeOperation {
  private UUID oldParent;
  private UUID newParent;
  private UUID uuid;

  public MoveNode(UUID uuid, UUID oldParent, UUID newParent) {
    this.uuid = uuid;
    this.oldParent = oldParent;
    this.newParent = newParent;
  }

  @Override
  public void apply(ITreeStorage storage) {
    storage.moveNodeTo(uuid, newParent);
  }

  @Override
  public String toString() {
    return "Moved " + uuid + " from " + oldParent + " to " + newParent;
  }

  @Override
  public void rollback(ITreeStorage storage) {
    storage.moveNodeTo(uuid, oldParent);
  }
}
