package com.unitesk.requality.core.transaction;

import java.util.Map;
import java.util.UUID;
import com.unitesk.requality.core.ChangesSet;
import com.unitesk.requality.core.ITreeStorage;
import com.unitesk.requality.core.attribute.Version;

public class SaveVersions extends TreeOperation {
  private UUID uuid;
  private ChangesSet<Version> changed;

  public SaveVersions(UUID uuid,ChangesSet<Version> ch, Map<String, Version> oldVersion, Map<String, Version> newVersion) {
    //TODO remove old map
    this.uuid = uuid;
    this.changed = new ChangesSet<>(ch);
  }
  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Save versions ");
    sb.append(uuid);
    return sb.toString();
    // return super.toString();
  }

  @Override
  public void apply(ITreeStorage storage) {
    storage.saveVersions(uuid, changed);
  }

  @Override
  public void rollback(ITreeStorage storage) {
    storage.saveVersions(uuid, changed.getReverted());
  }
}
