package com.unitesk.requality.report;

import com.unitesk.requality.core.TreeDB;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.core.attribute.IReqURIResolver;
import com.unitesk.requality.core.attribute.ReqURIResolveResult;
import com.unitesk.requality.core.instancer.Instantiator;

public class DefaultReportURIResolver implements IReqURIResolver{
  TemplateFile tf = null;
  public DefaultReportURIResolver(TemplateFile t){
    tf = t;
  }
  @Override
  public ReqURIResolveResult resolve(TreeNode node, String path, String value) {
    TreeNode trg = node.getTreeDB().getNode(path);
    if(trg!=null){
      String did = trg.attrs().getStringAttributeValue(TreeNode.ATTR_DOORS_ID);
      if(did!=null){
        TreeDB db = node.getTreeDB(),tdb = trg.getTreeDB();
        String nw = null;
        boolean tv = false;
        if(value.contains(did)){
          nw = value;
          tv = true;
        }else
          nw = did;
        if(db!=tdb){
          if(Instantiator.getRootTree(db)!=Instantiator.getRootTree(tdb)){
            String dname = tdb.getResName().toUpperCase();
            if(tv)
              nw = dname+"::"+nw;
            return new ReqURIResolveResult(getTemplateFileName(tdb)+"#"+did, nw);
          }
        }
        return new ReqURIResolveResult("#"+did, nw);
      }
    }
    return null;
  }
  public String getTemplateFileName(TreeDB db){
    return tf.getOutputFileName(db);
  }
}
