package com.unitesk.requality.tools.reqif;

import java.util.LinkedList;
import java.util.List;

import com.unitesk.requality.core.TreeNode;

public class RequalityReqIfAttributesConverter {
  List<NodeAttributeConverter> converters = new LinkedList<>();
  SingleAttributeConverter sac;

  public RequalityReqIfAttributesConverter(
      List<NodeAttributeConverter> convs, SingleAttributeConverter def) {
    converters.addAll(convs);
    sac = def;
  }

  private void registerConverter(NodeAttributeConverter sac) {
    converters.add(sac);
  }

  public void convertReqToDoors(TreeNode node, SpecObject object, ReqIFModel model) {
    for (NodeAttributeConverter sac2 : converters) sac2.requality2Doors(node, object, model);
  }

  public void convertDoorsToReq(SpecObject object, TreeNode node, ReqIFModel model) {
    for (NodeAttributeConverter sac2 : converters) sac2.doors2Requality(object, node, model);
  }
}
