package com.unitesk.requality.eclipse.api;

import java.util.ArrayList;
import java.util.Collection;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import com.unitesk.requality.core.api.API;
import com.unitesk.requality.core.api.IAPISource;
import com.unitesk.requality.core.api.MassOppDescriptor;
import com.unitesk.requality.core.descriptors.CoverageStorageSourceDescriptor;
import com.unitesk.requality.core.operations.mass.MassAttributeTypeChange;
import com.unitesk.requality.core.operations.mass.MassAttributeValueChange;
import com.unitesk.requality.core.operations.mass.MassDoorsIDImporter;
import com.unitesk.requality.eclipse.Activator;
import com.unitesk.requality.eclipse.wizards.ProjectMappingPage;
import com.unitesk.requality.eclipse.wizards.massops.AbstractExtraSettingsPage;
import com.unitesk.requality.eclipse.wizards.massops.AttrTypeChangeExtraSettingsPage;
import com.unitesk.requality.eclipse.wizards.massops.AttrValueChangeExtraSettingsPage;
import com.unitesk.requality.eclipse.wizards.massops.ReqIFFIleSelectionPage;
import com.unitesk.requality.report.Template;

public class EclipseAPI implements IAPISource {
  private static Collection<MassOppDescriptor> descrs;

  {
    descrs = new ArrayList<>();

    descrs.add(
        new MassOppDescriptorWithPages(
            "com.requality.attributeValueChange",
            "AttributeValueChange",
            new MassAttributeValueChange(),
            false) {
          @Override
          public List<Class<? extends AbstractExtraSettingsPage>> getPages() {
            List<Class<? extends AbstractExtraSettingsPage>> l =
                new LinkedList<>();
            l.add(AttrValueChangeExtraSettingsPage.class);
            return l;
          }
        });
    descrs.add(
        new MassOppDescriptorWithPages(
            "com.requality.attributeTypeChange",
            "AttributeTypeChange",
            new MassAttributeTypeChange(),
            false) {
          @Override
          public List<Class<? extends AbstractExtraSettingsPage>> getPages() {
            List<Class<? extends AbstractExtraSettingsPage>> l =
                new LinkedList<>();
            l.add(AttrTypeChangeExtraSettingsPage.class);
            return l;
          }
        });
    descrs.add(
        new MassOppDescriptorWithPages(
            MassDoorsIDImporter.ID, "DoorsIdImporter", new MassDoorsIDImporter(), false) {
          @Override
          public List<Class<? extends AbstractExtraSettingsPage>> getPages() {
            List<Class<? extends AbstractExtraSettingsPage>> l =
                new LinkedList<>();
            l.add(ReqIFFIleSelectionPage.class);
            l.add(ProjectMappingPage.class);
            return l;
          }
        });
    //		descrs.add(new MassOppDescriptorWithPages(
    //			add(new MassOppDescriptor("com.requality.attributeValueChange", "AttributeValueChange", new MassAttributeValueChange()));
    //			add(new MassOppDescriptor("com.requality.attributeTypeChange", "AttributeTypeChange", new MassAttributeTypeChange()));))
  }

  public static void init() {
    API.register(new EclipseAPI());
  }

  @Override
  public Collection<MassOppDescriptor> loadMassOpsDescriptors() {
    return descrs;
  }

  @Override
  public Map<String, Template> getReportTemplates() {
    return Activator.getDefault().getReportTemplates();
  }

  @Override
  public Map<String, CoverageStorageSourceDescriptor> getCoverageSources() {
    return Activator.getCoverageSources();
  }
}
