package com.unitesk.requality.eclipse.core;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.core.runtime.jobs.Job;

public abstract class RepeatingJob extends Job {
  protected boolean running = true;
  protected boolean pause = false;
  protected long repeatDelay = 0;

  public RepeatingJob(String jobName, long repeatPeriod) {
    super(jobName);
    repeatDelay = repeatPeriod;
  }

  protected IStatus run(IProgressMonitor monitor) {
    if (!running) return Status.CANCEL_STATUS;
    schedule(repeatDelay);
    return Status.OK_STATUS;
  }

  @Override
  public boolean shouldSchedule() {
    return running;
  }

  public void stop() {
    running = false;
  }

  public void pause() {
    pause = true;
  }

  public void start() {
    pause = false;
  }
}
