/**
 * ***************************************************************************** Institute for
 * System Programming of the Russian Academy of Sciences Copyright (c) 2009-2013 All rights
 * reserved. This program and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * ****************************************************************************
 */
package com.unitesk.requality.eclipse.cvs;

import java.util.List;

import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;

public abstract class CVSSourcePlugin implements BundleActivator {
  protected static BundleContext context;
  protected static CVSSourcePlugin plugin;

  static final BundleContext getContext() {
    return context;
  }

  protected abstract void actualStart(BundleContext bundleContext) throws Exception;

  protected abstract void actualStop(BundleContext bundleContext) throws Exception;

  public final void start(BundleContext bundleContext) throws Exception {
    CVSSourcePlugin.context = bundleContext;
    CVSSourcePlugin.plugin = this;

    actualStart(bundleContext);
  }

  public void stop(BundleContext bundleContext) throws Exception {
    actualStop(bundleContext);
    CVSSourcePlugin.context = null;
    CVSSourcePlugin.plugin = null;
  }

  public static CVSSourcePlugin getDefault() {
    return plugin;
  }

  public abstract List<String> getSupportedTeamProvidersIDList() throws Exception;

  public abstract ICVSClient getInstanceOfSVCClient() throws Exception;
}
