package com.unitesk.requality.eclipse.handlers;

import java.util.List;
import java.util.Map;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.swt.dnd.Clipboard;
import org.eclipse.swt.dnd.TextTransfer;
import org.eclipse.swt.dnd.Transfer;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.commands.IElementUpdater;
import org.eclipse.ui.menus.UIElement;

import com.unitesk.requality.core.selection.SelectionManager;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.nodetypes.Requirement;

public class CopyNodeQId extends AbstractHandler implements IElementUpdater {

  @Override
  public Object execute(ExecutionEvent event) throws ExecutionException {
    List<TreeNode> nodes = SelectionManager.getOne().getSelectedNodes();
    if (nodes == null || nodes.size() != 1) return null;
    String nodeFullName;
    if (nodes.get(0).getTreeDB().getFullNameMode())
      nodeFullName = nodes.get(0).getUserVisibleName(false);
    else nodeFullName = Requirement.getFullName(nodes.get(0), nodes.get(0).getTreeDB(), false);

    Clipboard clipboard = new Clipboard(PlatformUI.getWorkbench().getDisplay());
    TextTransfer textTransfer = TextTransfer.getInstance();
    clipboard.setContents(new String[] {nodeFullName}, new Transfer[] {textTransfer});
    clipboard.dispose();
    return null;
  }

  @Override
  public boolean isEnabled() {
    List<TreeNode> nodes = SelectionManager.getOne().getSelectedNodes();
    if (nodes == null || nodes.size() != 1) return false;
    return super.isEnabled();
  }

  @SuppressWarnings("rawtypes")
  @Override
  public void updateElement(UIElement element, Map parameters) {
    List<TreeNode> nodes = SelectionManager.getOne().getSelectedNodes();
    if (nodes != null && !nodes.isEmpty() && nodes.get(0).getTreeDB().getFullNameMode())
      element.setText("Copy User-Visible Name");
    else element.setText("Copy Full Name");
  }
}
