package com.unitesk.requality.eclipse.handlers;

import java.util.List;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchWindow;

import com.unitesk.requality.core.selection.SelectionManager;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.eclipse.Activator;
import com.unitesk.requality.nodetypes.Requirement;
import com.unitesk.requality.nodetypes.TestPurpose;
import com.unitesk.requality.tests.TestDialogProvider;

public class CreateNewTest extends AbstractHandler {
  @Override
  public Object execute(ExecutionEvent event) throws ExecutionException {
    TreeNode node = SelectionManager.getOne().getSelectedNodes().get(0);
    return TestDialogProvider.fireTestCreation(node.getTreeDB(), node.getQualifiedId(), getShell());
  }

  @Override
  public boolean isEnabled() {
    List<TreeNode> nodes = SelectionManager.getOne().getSelectedNodes();
    if (nodes.size() != 1) return false;
    TreeNode node = nodes.get(0);
    return node.getType().equals(TestPurpose.TYPE_NAME)
        || node.getType().equals(Requirement.TYPE_NAME);
  }

  private static Shell getShell() {
    if (Activator.getDefault() == null) return null;
    IWorkbench w = Activator.getDefault().getWorkbench();
    if (w == null) return null;
    IWorkbenchWindow win = w.getActiveWorkbenchWindow();
    if (win == null) return null;
    return win.getShell();
  }
}
