package com.unitesk.requality.eclipse.handlers;

import com.unitesk.requality.core.CoreUtils;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.core.attribute.Flag;
import com.unitesk.requality.nodetypes.TestPurpose;
import com.unitesk.requality.tools.RequalityCLI;

public class CreateTestPurposeHandler extends NewElementHandler {

  @Override
  protected String getNewIdentifier(TreeNode par, String type,boolean filter) {
    String pid = par.getNameOrId() + "_T";
    if(filter)
      pid = CoreUtils.filterNodeId(pid);
    return RequalityCLI.getNextId(par, type, pid);
  };

  @Override
  public String[] getElementTypes() {
    return new String[] {TestPurpose.TYPE_NAME};
  }

  @Override
  protected void setElementSpecificAttributes(TreeNode nn) {
    nn.attrs().setConstAttribute(TestPurpose.ATTR_AUTHOR, System.getProperty("user.name", ""), Flag.HIDDEN);
    nn.attrs().setConstAttribute(TestPurpose.ATTR_STATUS, "in process", Flag.HIDDEN);
  }
}
