package com.unitesk.requality.eclipse.handlers;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.PlatformUI;

import com.unitesk.requality.core.TreeDB;
import com.unitesk.requality.core.checkers.DocumentRefsChecker;
import com.unitesk.requality.eclipse.core.EclipseChecker;
import com.unitesk.requality.eclipse.core.EclipseTracker;
import com.unitesk.requality.eclipse.natures.ReqCatalogue;

public class ForceCheckersHandler extends AbstractHandler {

  @Override
  public Object execute(ExecutionEvent event) throws ExecutionException {
    IStructuredSelection sel =
        (IStructuredSelection)
            PlatformUI.getWorkbench()
                .getActiveWorkbenchWindow()
                .getSelectionService()
                .getSelection();
    if (!(sel.getFirstElement() instanceof IProject)) return null;
    IProject project = (IProject) sel.getFirstElement();
    TreeDB db = EclipseTracker.getTracker().getTree(project);
    if (db == null) return null;
    try {
      db.clearAllCaches(false);
      project.close(null);
      project.open(null);
      EclipseChecker ecc = new EclipseChecker(true);
      ecc.runCheck(EclipseTracker.getTracker().getTree(project), new DocumentRefsChecker());
      project.refreshLocal(IResource.DEPTH_INFINITE, null);
    } catch (Exception ex) {
      ex.printStackTrace();
    }
    return null;
  }

  @Override
  public boolean isEnabled() {
    IStructuredSelection sel =
        (IStructuredSelection)
            PlatformUI.getWorkbench()
                .getActiveWorkbenchWindow()
                .getSelectionService()
                .getSelection();
    if (sel.getFirstElement() instanceof IProject) {
      IProject project = (IProject) sel.getFirstElement();
      try {
        if (!project.isAccessible()) return false;
        if (project.hasNature(ReqCatalogue.ID)) {
          return true;
        }
      } catch (CoreException e) {
        e.printStackTrace();
      }
    }
    return false;
  }
}
