package com.unitesk.requality.eclipse.handlers;


import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.DirectoryDialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.PlatformUI;
import org.json.JSONException;

import com.unitesk.requality.core.TreeDB;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.eclipse.core.EclipseTracker;
import com.unitesk.requality.eclipse.natures.ReqCatalogue;
import com.unitesk.requality.eclipse.storageformatversion.LegalicyNodeMapper;
import com.unitesk.requality.tools.RequalityCLI;

public class SaveToOld extends AbstractHandler {

  @Override
  public Object execute(ExecutionEvent event) throws ExecutionException {
    IStructuredSelection sel =
        (IStructuredSelection)
            PlatformUI.getWorkbench()
                .getActiveWorkbenchWindow()
                .getSelectionService()
                .getSelection();
    if (!(sel.getFirstElement() instanceof IProject)) return null;
    IProject project = (IProject) sel.getFirstElement();
    TreeDB db = EclipseTracker.getTracker().getTree(project);
    LegalicyNodeMapper lnm = new LegalicyNodeMapper();
    Shell shell = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell();
    shell.open();


    DirectoryDialog dialog = new DirectoryDialog(shell, SWT.OPEN);
    String result = dialog.open();
    Display display = shell.getDisplay();
                                    // wild
//                                    // cards
//    while (!shell.isDisposed()) {
//      if (!display.readAndDispatch())
//        display.sleep();
//    }
//    display.dispose();
    File fold = new File(result);
    try {
		recHndl(db.getRootNode(),fold,lnm);
	} catch (JSONException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	} catch (Exception e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	}
    return null;
  }

  private void recHndl(TreeNode rootNode, File fold, LegalicyNodeMapper lnm) throws JSONException, IOException {
	  String id = rootNode.getId();
	  if(id.equals("/"))
		  id = "root";
	  File f = new File(fold.toPath()+File.separator+id+".json");
	  f.createNewFile();
	  OutputStreamWriter out = new OutputStreamWriter(new FileOutputStream(f), "UTF-8");
      String jsonStrring = lnm.toJSON(rootNode).toString(4);
      out.append(jsonStrring);
      out.close();
      File rf = new File(fold.toPath()+File.separator+id+"_resources");
      for(String s:rootNode.listResources()){
    	  if(!rf.exists())
    		  rf.mkdirs();
    	  File r = new File(rf.toPath()+File.separator+s);
    	  r.getParentFile().mkdirs();
    	  r.createNewFile();
    	  RequalityCLI.copyfile(rootNode.getResource(s).toURI(), r.toURI());
      }
      TreeNode[]tn=rootNode.getWorkChildren();
      if(tn.length>0){
    	  File ff = new File(fold.toPath()+File.separator+id);
    	  if(!ff.exists())
    		  ff.mkdirs();
    	  for(TreeNode node:tn)
    		  recHndl(node, ff, lnm);
      }
  }

@Override
  public boolean isEnabled() {
    IStructuredSelection sel =
        (IStructuredSelection)
            PlatformUI.getWorkbench()
                .getActiveWorkbenchWindow()
                .getSelectionService()
                .getSelection();
    if (sel.getFirstElement() instanceof IProject) {
      IProject project = (IProject) sel.getFirstElement();
      try {
        if (!project.isAccessible()) return false;
        if (project.hasNature(ReqCatalogue.ID)) {
          return true;
        }
      } catch (CoreException e) {
        e.printStackTrace();
      }
    }
    return false;
  }
}
