package com.unitesk.requality.eclipse.handlers;

import java.util.List;

import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.IHandler;
import org.eclipse.core.commands.IHandlerListener;
import org.eclipse.ui.PlatformUI;

import com.unitesk.requality.core.selection.SelectionManager;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.eclipse.ui.dialogs.TraceabilityReportSettingsDialog;
import com.unitesk.requality.nodetypes.ReportSettings;

public class SetTraceabilitySettings implements IHandler {

  @Override
  public void addHandlerListener(IHandlerListener handlerListener) {
    // TODO Auto-generated method stub

  }

  @Override
  public void dispose() {
    // TODO Auto-generated method stub

  }

  @Override
  public Object execute(ExecutionEvent event) throws ExecutionException {
    TreeNode node = (TreeNode) event.getParameters().get("target");
    TraceabilityReportSettingsDialog wiz =
        new TraceabilityReportSettingsDialog(
            PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell(), node);
    try {
      return wiz.open();
    } catch (Exception e) {
      e.printStackTrace();
    }
    return null;
  }

  @Override
  public boolean isEnabled() {
    return isHandled();
  }

  @Override
  public boolean isHandled() {
    List<TreeNode> nodes = SelectionManager.getOne().getSelectedNodes();
    if (nodes == null) return false;
    if (nodes.size() != 1) return false;
    if (!nodes.get(0).getType().equals(ReportSettings.TYPE_NAME)) return false;
    String s = ((ReportSettings) nodes.get(0)).getTemplateId();
    if (s == null) return false;
    return true;
  }

  @Override
  public void removeHandlerListener(IHandlerListener handlerListener) {
    // TODO Auto-generated method stub

  }
}
