package com.unitesk.requality.eclipse.handlers;

import java.util.List;
import java.util.UUID;
import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.core.selection.SelectionManager;
import com.unitesk.requality.nodetypes.VirtualNode;

public class ShowHiddenChildrenForNode extends AbstractHandler {

  @Override
  public Object execute(ExecutionEvent event) throws ExecutionException {
    List<TreeNode> nodes = SelectionManager.getOne().getSelectedNodes();
    if (nodes == null || nodes.size() < 1) return null;
    try {
      nodes.get(0).getTreeDB().startTransaction("Show hidden elements");
      for (TreeNode node : nodes) {
        for (UUID uuid : node.getWorkChildrenUUIDs()) {
          //Instantiator.getVirtualStorage(node.getTreeDB(),Instantiator.DEFAULT_INSTANCE_NAME);
          TreeNode node2 = nodes.get(0).getTreeDB().getNode(uuid);
          if (node2.getTreeDB().isHidden(uuid)) {
            VirtualNode.setHidden(node2, false);
            //ti.undeleteHidden(uuid);
          }
          if (node2.getType().equals(VirtualNode.TYPE_NAME)) {
            ((VirtualNode) node2).unCollapse();
            node2.commitAttributes();
            //TODO updatechildren
          } else if (node2.isVirtual()) {
            node2.attrs().removeAttribute(VirtualNode.ATTR_HIDDEN_STATUS);
            node2.commitAttributes();
          }
        }
        //node.getTreeDB().updateNodeChildren(node);
      }
      nodes.get(0).getTreeDB().commit();
    } catch (Exception e) {
      nodes.get(0).getTreeDB().rollback();
    }
    return null;
  }

  @Override
  public boolean isEnabled() {
    List<TreeNode> nodes = SelectionManager.getOne().getSelectedNodes();
    if (nodes == null) {
      return false;
    }
    for (TreeNode node : nodes) {
      for (UUID uid : node.getWorkChildrenUUIDs()) {
        //TODO another sts?
        if (node.getTreeDB().isHidden(uid)) return true;
        TreeNode nd = node.getTreeDB().getNode(uid);
        if (nd.getType().equals(VirtualNode.TYPE_NAME) && ((VirtualNode) nd).isCollapsed())
          return true;
      }
    }
    return false;
  }
}
