package com.unitesk.requality.eclipse.handlers.copypaste;

import java.util.List;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.PlatformUI;

import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.core.selection.SelectionManager;
import com.unitesk.requality.eclipse.Activator;

public class PasteIntoHandler extends AbstractHandler {
  com.unitesk.requality.core.operations.PasteIntoHandler base =
      new com.unitesk.requality.core.operations.PasteIntoHandler() {
        @Override
        protected void showError(String title, String message) {
          MessageDialog.openError(
              PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell(), title, message);
        }

        @Override
        protected boolean showConfirm(String title, String desc) {
          return MessageDialog.openConfirm(
              PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell(), title, desc);
        }
      };

  @Override
  public Object execute(ExecutionEvent event) throws ExecutionException {
    List<TreeNode> parent = SelectionManager.getOne().getSelectedNodes();
    if (parent == null || parent.size() != 1) return null;
    return pasteNodes(parent.get(0), null, true, false, false, false);
  }

  public Object pasteNodes(TreeNode parent, boolean copyTree) {
    return pasteNodes(parent, null, copyTree, false, false, false);
  }

  public Object pasteNodes(
      TreeNode parent,
      TreeNode lastnode,
      boolean copyTree,
      boolean skipTransaction,
      boolean skipDialogs,
      boolean autoRename) {
    Activator a = Activator.getDefault();
    Shell shell = null;
    if (a != null) Activator.getDefault().getWorkbench().getActiveWorkbenchWindow().getShell();
    if (a == null) skipDialogs = true;
    return base.pasteNodes(parent, lastnode, copyTree, skipTransaction, skipDialogs, autoRename);
  }

  public boolean checkInto() {
    List<TreeNode> nodes = SelectionManager.getOne().getSelectedNodes();
    return base.checkInto(nodes);
  }

  @Override
  public boolean isEnabled() {
    return checkInto();
  }
}
