package com.unitesk.requality.eclipse.handlers.copypaste;

import java.util.List;

import org.eclipse.core.commands.ExecutionException;

import com.unitesk.requality.core.NodeDesc;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.core.operations.CopyPasteHelper;
import com.unitesk.requality.core.selection.SelectionManager;
import com.unitesk.requality.nodetypes.Requirement;

public class PasteSiblingHandler extends PasteIntoHandler {

  @Override
  public Object execute(org.eclipse.core.commands.ExecutionEvent event) throws ExecutionException {
    List<TreeNode> parent = SelectionManager.getOne().getSelectedNodes();
    if (parent == null || parent.size() != 1) return null;
    return pasteNodes(parent.get(0).getShownParent(), parent.get(0), true, false, false, false);
  };

  public boolean checkSibling() {
    List<TreeNode> parent = SelectionManager.getOne().getSelectedNodes();
    if (parent == null || parent.size() != 1) return false;
    TreeNode node = parent.get(0);
    List<NodeDesc> nodes = CopyPasteHelper.getInstance().getNodes();
    if (CopyPasteHelper.getInstance().isEmpty()) return false;
    for (NodeDesc nd : nodes)
      if (!node.getTreeDB().getTreeLogic().canBeCreatedIn(nd.getType(), node.getShownParent()))
        return false;

    if (node.getType().equals(Requirement.TYPE_NAME))
      return !node.getQualifiedId().equals(Requirement.getTypeRootQId());
    return true;
  }

  @Override
  public boolean isEnabled() {
    return checkSibling();
  }
}
