package com.unitesk.requality.eclipse.handlers.location;

import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.ui.IEditorReference;
import org.eclipse.ui.PlatformUI;
import com.unitesk.requality.core.Path;
import com.unitesk.requality.core.TreeDB;
import com.unitesk.requality.eclipse.RequalityPlugin;
import com.unitesk.requality.eclipse.editors.browser.ReqMarker;
import com.unitesk.requality.nodetypes.Document;
import com.unitesk.requality.nodetypes.Location;
import com.unitesk.requality.nodetypes.Requirement;

public class CommonRemoveLocation
    extends com.unitesk.requality.core.operations.CommonRemoveLocation {

  //parameterized removing locations:
  //if req != null, then from requirement req, else from everywhere;
  //if reqMarker != null, then from Markup Editor reqMarker, else search any Markup Editor
  //if batch, then asks, else TRANSACTION MUST BE STARTED!
  @Override
  public void removeFragment(
      Location loc,
      List<Requirement> reqs,
      boolean batch,
      String locID /*for deleted*/,
      TreeDB db) {
    if (reqs == null || loc.getRequirements().length == 0) {
      Document doc = null;
      if (loc != null) doc = (Document) loc.getWorkParent();
      else doc = (Document) db.getNode(locID.substring(0, locID.lastIndexOf("/")), Path.QID);
      if (doc != null) {
        ReqMarker reqMarker = null;
        //if (reqMarker == null) {
          IEditorReference eRef = null;
          try {
            eRef = RequalityPlugin.findMarkEditorForDocument(doc.getQualifiedId(true));
          } catch (Exception e) {
            e.printStackTrace();
          }
          if (eRef != null
              && eRef.getEditor(true) != null
              && (eRef.getEditor(true) instanceof ReqMarker)) {
            reqMarker = (ReqMarker) eRef.getEditor(true);
          }
        //}
        //if (reqMarker != null) {
          if(reqMarker!=null){
            try{
              if (loc == null)
                 reqMarker
                        .getBrowser()
                        .deleteLocation(locID.substring(locID.lastIndexOf("/") + 1));
              //js = doc.removeLocationRegion(locID.substring(locID.lastIndexOf("/")+1));
              else {
                String[] rem = new String[] {loc.getUUId().toString(), loc.getRawId()};
                reqMarker.getBrowser().deleteLocations(new HashSet<>(Arrays.asList(rem)));
              }
            }catch(Exception e){
              e.printStackTrace();
            }
          }
          super.removeFragment(loc, reqs, batch, locID, db);//The actual remove
          //reqMarker.saveDocument(js); //1
        //}
      }
    }
  }

  @Override
  public boolean openConfirm(String title, String message) {
    return MessageDialog.openConfirm(
        PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell(), title, message);
  }

  @Override
  public void openError(String title, String message) {
    MessageDialog.openError(
        PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell(), title, message);
  }
  @Override
  public void removeFragments(Map<Location, List<Requirement>> locs, boolean b) {
    Map<Document, List<String>> torem = new HashMap<>();
    for(Location loc : locs.keySet()){
      List<Requirement> reqs = locs.get(loc);
      if (reqs == null || loc.getRequirements().length == 0 || Arrays.equals(loc.getRequirements(),reqs.toArray())) {
        Document doc = (Document) loc.getWorkParent();
        //else doc = (Document) db.getNode(locID.substring(0, locID.lastIndexOf("/")), Path.QID);
        if (doc != null) {
          if(!torem.containsKey(doc))
            torem.put(doc, new LinkedList<>());
          torem.get(doc).add(loc.getUUId().toString());
          //String[] rem = new String[] {loc.getUUId().toString(), loc.getRawId()};
          
          // }
        }
      }
    }
    for(Document doc:torem.keySet()){
      ReqMarker reqMarker = null;
      //if (reqMarker == null) {
        IEditorReference eRef = null;
        try {
          eRef = RequalityPlugin.findMarkEditorForDocument(doc.getQualifiedId(true));
        } catch (Exception e) {
          e.printStackTrace();
        }
        if (eRef != null
            && eRef.getEditor(true) != null
            && (eRef.getEditor(true) instanceof ReqMarker)) {
          reqMarker = (ReqMarker) eRef.getEditor(true);
        }
      //}
      //if (reqMarker != null) {
        if(reqMarker!=null){
          try{
            reqMarker
                      .getBrowser()
                      .deleteLocations(new HashSet<>(torem.get(doc)));
            //js = doc.removeLocationRegion(locID.substring(locID.lastIndexOf("/")+1));
          }catch(Exception e){
            e.printStackTrace();
          }
        }
      try {
        doc.getDOM();
      } catch (Exception e) {
        e.printStackTrace();
      }
      String js = doc.removeLocationRegions(new HashSet<>(torem.get(doc)));
      doc.saveDOM(js, doc.getXmlDoc());
      doc.reloadLocationUUIdToIndex();//TODO make more core
    }
  }
  
}
