package com.unitesk.requality.eclipse.operations;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.operations.AbstractOperation;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;

import com.unitesk.requality.core.transaction.TransactionStorage;

public class TreeDBOperation extends AbstractOperation {
  private TransactionStorage tstorage;

  public TreeDBOperation(TransactionStorage tstorage) {
    super(tstorage.getName());
    this.tstorage = tstorage;
  }

  @Override
  public IStatus execute(IProgressMonitor monitor, IAdaptable info) throws ExecutionException {
    return Status.CANCEL_STATUS;
  }

  @Override
  public boolean canExecute() {
    return false;
  }

  @Override
  public IStatus redo(IProgressMonitor monitor, IAdaptable info) throws ExecutionException {
    tstorage.apply(tstorage.getStorage());
    return Status.OK_STATUS;
  }

  @Override
  public IStatus undo(IProgressMonitor monitor, IAdaptable info) throws ExecutionException {
    tstorage.rollback(tstorage.getStorage());
    return Status.OK_STATUS;
  }

  @Override
  public void dispose() {
    tstorage.dispose();
  }
}
