package com.unitesk.requality.eclipse.storageformatversion;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.UUID;
import org.eclipse.core.resources.IContainer;
import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.CoreException;
import org.json.JSONException;
import com.unitesk.requality.core.NodeMapper;
import com.unitesk.requality.core.attribute.AttributeDefinition;

public abstract class OldTo0212Convert {
  static String NODE_GROUP = "com.unitesk.nodegroup.requality";
  abstract Map<String,AttributeDefinition> reworkAttrs(UUID uid, Map<String,AttributeDefinition> ad);
  
  public String convert(IProject proj) {
    // TODO Auto-generated method stub
    try {
      //List<String> vers = new ArrayList<String>();
      processContainer(proj, "");
      List<String> vers = StoredFormatVersioning.getFormatsVersions(proj);
      if(vers!=null){
        for(String s:new HashSet<>(vers))
          if(s.startsWith(NODE_GROUP+"|"))
            vers.remove(s);
      }
      else
        vers = new ArrayList<>();
      vers.add(StoredFormatVersioning.getFullVersionByGroupId(NODE_GROUP));
      StoredFormatVersioning.setFormatsVersions(proj, vers);
      proj.refreshLocal(IResource.DEPTH_INFINITE, null);
    } catch (Exception e) {
      ByteArrayOutputStream baos = new ByteArrayOutputStream();
      PrintWriter pw = new PrintWriter(baos);
      e.printStackTrace(pw);
      pw.close();
      try {
        baos.close();
      } catch (IOException e1) {
      }
      return baos.toString();
    }
    return null;
  }
  
  void processContainer(IContainer container,String path) throws CoreException
  {
     IResource [] members = container.members();
     for (IResource member : members)
      {
        if (member instanceof IContainer) 
         {
          if(member.getName().equals("Instances")){
            member.delete(true, null);
            continue;
          }
           processContainer((IContainer)member,path+"/"+member.getName());
         }
        else if (member instanceof IFile)
         {
          IFile f = (IFile) member;
          if(f.getName().equals("Instances.json")){
            f.delete(true, null);
            continue;
          }
          if(f.getName().endsWith("json")){
            handleFile(path+"/"+f.getName(),f);
          }
         }
      }
  }

  protected void handleFile(String path, IFile f) throws CoreException {
      UUID uid = ResHelper.getFileUUID(f);
      if(uid!=null){
        try {
          Map<String,AttributeDefinition> map = LegalicyNodeMapper.getAttributes(uid, ResHelper.readFile(f));
          map = reworkAttrs(uid,map);
          String val = NodeMapper.toJSON(uid, map.values(), true).toString(4);
          if (f.exists()) {
            ByteArrayInputStream in = null;
            try{
              in = new ByteArrayInputStream(val.getBytes("UTF-8"));
              f.refreshLocal(0, null);
              f.setContents(in, true, true, null);
            }
            finally{
              if(in != null)
                try {
                  in.close();
                } catch (IOException e) {
                  // TODO Auto-generated catch block
                  e.printStackTrace();
                }
            }
          } else{
            ByteArrayInputStream in = null;
            try {
              in = new ByteArrayInputStream(val.getBytes("UTF-8"));
              f.create(in, true, null);
            } catch (CoreException re) {
              try {
                in = new ByteArrayInputStream(val.getBytes("UTF-8"));
                f.setContents(in, true, true, null);
              } catch (CoreException re2) {
                re2.printStackTrace();
              }
            }
            finally{
              if(in != null)
                try {
                  in.close();
                } catch (IOException e) {
                  // TODO Auto-generated catch block
                  e.printStackTrace();
                }
            }
          }
        } catch (JSONException e) {
          // TODO Auto-generated catch block
          e.printStackTrace();
        } catch (UnsupportedEncodingException e) {
          // TODO Auto-generated catch block
          e.printStackTrace();
        }
      }
  }
}
