package com.unitesk.requality.eclipse.storageformatversion;

import java.util.Scanner;
import java.util.UUID;
import org.eclipse.core.resources.IFile;
import org.eclipse.core.runtime.CoreException;
import org.json.JSONException;
import com.unitesk.requality.core.NodeMapper;

public class ResHelper {
  public static UUID getFileUUID(IFile file) {
    try {
      String content = readFile(file);
      if (content == null) return null;
      return NodeMapper.getUUId(content);
    } catch (JSONException e) {

      e.printStackTrace();
      // random uuid for error node
      return UUID.randomUUID();
    }
  }
  public static String readFile(IFile file) {
    try {
      String fileExt = file.getFileExtension();
      if (fileExt == null || !fileExt.equals("json") || !file.exists()) {
        return null;
      }
      StringBuilder jsonsb = new StringBuilder();
      Scanner s = new Scanner(file.getContents(true), file.getCharset());
      while (s.hasNextLine()) {
        jsonsb.append(s.nextLine().trim());
        jsonsb.append("\n");
      }
      s.close();
      return jsonsb.toString();
    } catch (CoreException e) {
      e.printStackTrace();
    }
    return null;
  }
}
