package com.unitesk.requality.eclipse.views.actions;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.jface.action.ActionContributionItem;
import org.eclipse.jface.action.IContributionItem;
import org.eclipse.jface.action.MenuManager;

import com.unitesk.requality.core.TreeDB;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.eclipse.handlers.NewElementHandler;

public class NewTypedMenuPoint extends MenuManager {

  private NewElementHandler neh;
  private TreeNode sel;
  private String tp;

  public NewTypedMenuPoint(TreeNode db, NewElementHandler neh, String type) {
    super(type + "...");
    this.sel = db;
    this.neh = neh;
    this.tp = type;
  }

  @Override
  public IContributionItem[] getItems() {
    List<IContributionItem> items = new ArrayList<>();
    String type = tp;
    items.add(
        new ActionContributionItem(
            new NewTypedTemplatedMenuPoint(sel, type, TreeDB.EMPTY_TEMPLATE, neh)));
    for (TreeNode s : sel.getTreeDB().getTemplates())
      if (type.equals(s.getType()))
        items.add(
            new ActionContributionItem(new NewTypedTemplatedMenuPoint(sel, type, s.getId(), neh)));
    if (items.size() == 1) return new IContributionItem[0];
    return items.toArray(new IContributionItem[0]);
  }
}
