package com.unitesk.requality.eclipse.views.actions;

import org.eclipse.swt.widgets.Event;

import com.unitesk.requality.core.TreeDB;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.eclipse.handlers.NewElementHandler;

public class NewTypedTemplatedMenuPoint extends org.eclipse.jface.action.Action {
  private String type, templ;
  private NewElementHandler neh;
  private TreeNode node;

  public NewTypedTemplatedMenuPoint(
      TreeNode sel, String type, String template, NewElementHandler neh) {
    this(
        sel,
        type,
        template,
        neh,
        (template == null || template.equals(TreeDB.EMPTY_TEMPLATE))
            ? "From Scratch"
            : ("From '" + template + "'"));
  }

  public NewTypedTemplatedMenuPoint(
      TreeNode sel, String type, String template, NewElementHandler neh, String label) {
    super(label);
    this.type = type;
    this.templ = template;
    this.neh = neh;
    node = sel;
  }

  @Override
  public void runWithEvent(Event event) {
    neh.execute(node, templ, type);
    //super.runWithEvent(event);
  }
}
