package com.unitesk.requality.eclipse.views.atypeeditors;

import org.eclipse.jface.viewers.ComboBoxCellEditor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;

import com.unitesk.requality.core.attribute.AttributeType;

public class BoolValueEditor extends ComboBoxCellEditor {
  static final String[] values = new String[] {"false", "true"};

  public BoolValueEditor(Composite parent, int style) {
    super(parent, values, style | SWT.READ_ONLY);
  }

  @Override
  protected Object doGetValue() {
    int ind = (Integer) super.doGetValue();
    return ind > -1 ? values[ind] : "false";
  }

  @Override
  protected void doSetValue(Object value) {
    if (value instanceof Boolean) super.doSetValue((Boolean) value ? 1 : 0);
    if (value instanceof Integer) super.doSetValue(value);
    super.doSetValue((Boolean) AttributeType.BOOL.fromString(value.toString()) ? 1 : 0);
  }
}
