package com.unitesk.requality.eclipse.wizards.massops;

import java.io.IOException;
import java.util.Set;
import org.eclipse.jface.dialogs.DialogSettings;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Text;
import com.unitesk.requality.core.RLogger;
import com.unitesk.requality.core.TreeDB;
import com.unitesk.requality.core.operations.mass.MassOppsArguments;

public class AttrValueChangeExtraSettingsPage extends AbstractExtraSettingsPage {

  private static final String LBL_CH_VALUE = "Type new value:	";
  private Text newAttrValue;

  public AttrValueChangeExtraSettingsPage(DialogSettings ds, Set<String> names, TreeDB db) {
    super("Attribute value change", ds, names, db);
    setTitle("Attribute Value Change Settings");
    dialogSettings = (DialogSettings) getDialogSettings();
  }

  @Override
  public void createControl(Composite parentP) {
    //		//super.createControl(parent);
    container = new Composite(parentP, SWT.None);
    GridLayout layout = new GridLayout();
    container.setLayout(layout);
    layout.verticalSpacing = 2;
    container.setLayout(layout);
    container.setLayoutData(new GridData(GridData.FILL_BOTH));
    leftright = new Composite(container, SWT.NONE);
    leftright.setLayoutData(new GridData(GridData.FILL_BOTH));
    leftright.setLayout(new GridLayout(2, true));

    left = new Composite(leftright, SWT.NONE);
    left.setLayout(new GridLayout(1, true));
    left.setLayoutData(new GridData(GridData.FILL_BOTH));

    right = new Composite(leftright, SWT.NONE);
    right.setLayout(new GridLayout(1, true));
    right.setLayoutData(new GridData(GridData.FILL_BOTH));

    down = new Composite(container, SWT.NONE);

    (new Label(left, SWT.None)).setText(LBL_ATTR_NAME);
    attrList = new List(left, SWT.V_SCROLL | SWT.H_SCROLL);
    attrList.addSelectionListener(listener);
    GridData gd = new GridData(GridData.FILL_BOTH);
    gd.heightHint = 300;
    attrList.setLayoutData(gd);
    if (attrNames == null || attrNames.isEmpty()) {
      attrList.setItems(new String[]{"There are no attributes"});
      attributesExist = false;
    } else {
      attrList.setItems(attrNames.toArray(new String[0]));
    }

    (new Label(right, SWT.NONE)).setText(LBL_ATTR_VALUE);
    attrValList = new List(right, SWT.V_SCROLL | SWT.H_SCROLL | SWT.READ_ONLY);
    attrValList.setBackground(
        Display.getDefault().getSystemColor(SWT.COLOR_TITLE_INACTIVE_BACKGROUND));
    gd = new GridData(GridData.FILL_BOTH);
    gd.heightHint = 300;
    attrValList.setLayoutData(gd);
    down.setLayout(new GridLayout());
    if (getAttributesExist()) attrList.addSelectionListener(listener);
    Label chValueLabel = new Label(down, SWT.None);
    chValueLabel.setText(LBL_CH_VALUE);
    chValueLabel.setLayoutData(new GridData(GridData.FILL_HORIZONTAL, GridData.CENTER, true, true));

    newAttrValue = new Text(down, SWT.BORDER);
    newAttrValue.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
    newAttrValue.addModifyListener(
        new ModifyListener() {

          @Override
          public void modifyText(ModifyEvent e) {
            //	setPageComplete(true);
            String newVal = newAttrValue.getText();
            getDialogSettings().put(MassOppsArguments.Argument.NEW_VALUE.name(), newVal);
            try {
              dialogSettings.save(MassOppsWizard.FILE_NAME);
            } catch (IOException e1) {
              RLogger.logInfo(e1);
            }
            if (getAttributeChoose()) setPageComplete(true);
          }
        });
    setControl(container);
  }

  private static String[] dnames = new String[] {};

  @Override
  public String[] getDialogNames() {
    return dnames;
  }

  @Override
  public void reloadSettingsFromDS() {
    // TODO Auto-generated method stub

  }
}
