package com.unitesk.requality.marker;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Set;
import org.eclipse.jface.viewers.IDecoration;
import org.eclipse.jface.viewers.ILabelDecorator;
import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Display;
import com.unitesk.requality.core.ITreeNodeProvider;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.eclipse.ui.cnf.RequalityCNF;
import com.unitesk.requality.eclipse.views.PrefixAndTreeNode;

public class LinksDecorator extends RequalityDecorator implements  ILabelDecorator {
  Color back;
  private static boolean isButtonEnable = false;
  private static boolean isColor = false;
  private static boolean isDispose = false;
  private static TreeNode node;
  private TreeNode ldnode = null;

  public LinksDecorator(){
    super();
  }
  public LinksDecorator(TreeNode tn){
    super();
    ldnode = tn;
  }
  
  public static boolean isButtonEnable() {
    return isButtonEnable;
  }

  public static void setButtonEnable(boolean isButtonEnable) {
    LinksDecorator.isButtonEnable = isButtonEnable;
  }

  public static void isColor(boolean isColor) {
    LinksDecorator.isColor = isColor;
  }

  public static void isDispose(boolean isDispose) {
    LinksDecorator.isDispose = isDispose;
  }

  @Override
  public void dispose() {
    if (back != null) {
      back.dispose();
    }
  }

  @Override
  public void decorate(Object telement, final IDecoration decoration) {
    if (PrefixAndTreeNode.class.isInstance(telement))
      telement = ((PrefixAndTreeNode)telement).getNode();
    if (TreeNode.class.isInstance(telement)) {
      final Display display = Display.getDefault();
      back = new Color(display, 255, 129, 163); // Color(171,221,250);
      if (isButtonEnable && (isColor || node.equals(telement))) {
        final Object element = telement;
        display.asyncExec(
          new Runnable() {
            @Override
            public void run() {
              if (isDispose) { //compulsion dispose
                dispose();
                isDispose = false;
              } else if (isButtonEnable && (isColor || node.equals(element))) {
                decoration.setBackgroundColor(back);
                node = (TreeNode) element;
                List<Object> list =
                    new ArrayList<>(
                        Arrays.asList(
                            RequalityCNF.activeNavigator.getCommonViewer().getExpandedElements()));
                TreeNode nde = node.getWorkParent();
                while (nde != null) {
                  list.add(nde);
                  nde = nde.getWorkParent();
                }
                RequalityCNF.activeNavigator.getCommonViewer().setExpandedElements(list.toArray());
                isColor = false;
              } else {
                dispose();
              }
            }
          });
      }
    }
  }

  @Override
  public boolean isLabelProperty(Object element, String property) {
    return true;
  }

  @Override
  public void addListener(ILabelProviderListener listener) {
    // TODO Auto-generated method stub

  }

  @Override
  public void removeListener(ILabelProviderListener listener) {
    // TODO Auto-generated method stub

  }

  @Override
  public Image decorateImage(Image arg0, Object arg1) {
    // TODO Auto-generated method stub
    return null;
  }

  @Override
  public String decorateText(String arg0, Object arg1) {
    if(arg1 instanceof ITreeNodeProvider){
      ITreeNodeProvider pf = (ITreeNodeProvider) arg1;
      String add = "";
      if(ldnode!=null && !ldnode.isSameTree(pf.getNode()))
        add = ((TreeNode)arg1).getTreeDB().getResName()+"::";
      return add+pf.toString();
    }
    if(arg1 instanceof TreeNode){
      String add = "";
      if(ldnode!=null && !ldnode.isSameTree(((TreeNode)arg1)))
        add = ((TreeNode)arg1).getTreeDB().getResName()+"::";
      return add+((TreeNode)arg1).getUserVisibleName();
    }
    return arg1.toString();
  }

  @Override
  public Set<String> getRelatedKeys() {
    return Collections.emptySet();
  }

  public void setNode(TreeNode object) {
    ldnode = object;
  }
}
