package com.unitesk.requality.marker;

import java.util.HashSet;
import java.util.Set;
import org.eclipse.core.resources.IMarker;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.viewers.IDecoration;
import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.jface.viewers.ILightweightLabelDecorator;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.eclipse.Activator;
import com.unitesk.requality.eclipse.core.EclipseTracker;

public class RequalityDecorator implements ILightweightLabelDecorator {
  public Set<String> getRelatedKeys(){
    return null;
  }
  private static Set<RequalityDecorator> desc = new HashSet<>();
  public static Set<RequalityDecorator> getAll() {
    return desc;
  }
  public RequalityDecorator() {
    synchronized (desc){
      desc.add(this);
    }
  }
  @Override
  public void addListener(ILabelProviderListener listener) {}

  @Override
  public void dispose() {}

  @Override
  public void decorate(Object element, IDecoration decoration) {
    if (!TreeNode.class.isInstance(element)) {
      return;
    }
    TreeNode node = (TreeNode) element;
    // TODO: change depth if it slows down much
    IMarker[] markers = null;
    try {
      IResource res = EclipseTracker.getResourceByNode(node);
      if (res == null || !res.exists()) {
        return;
      }
      //IMark[] probs = node.getTreeDB().getCheckerProblems(node);
      //if(probs!=null && probs.length>0)
      //EclipseCheckerContainer.applyProblemsInfo(res, probs);
      markers = res.findMarkers(IMarker.PROBLEM, true, IResource.DEPTH_ZERO);
      //            if (markers.length == 0) {
      //                IFolder chFolder = res.getParent().getFolder(
      //                        Path.fromOSString(node.getId()));
      //                if (chFolder.exists()) {
      //                    markers = chFolder.findMarkers(IMarker.PROBLEM, true,
      //                            IResource.DEPTH_INFINITE);
      //                }
      //            }
    } catch (CoreException e) {
      e.printStackTrace();
    }
    if (markers == null) {
      return;
    }
    if (markers.length == 0) {
      return;
    }
    ImageDescriptor id =
        Activator.getImageDescriptor("org.eclipse.ui", "icons/full/ovr16/error_ovr.gif");
    decoration.addOverlay(id);
  }

  @Override
  public void removeListener(ILabelProviderListener listener) {}

  @Override
  public boolean isLabelProperty(Object element, String property) {
    return true;
  }
  
}
