package com.unitesk.requality.marker;

import java.util.Collections;
import java.util.Set;
import org.eclipse.jface.viewers.IDecoration;
import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.widgets.Display;
import com.unitesk.requality.core.TreeNode;

public class SelectedRefTargetDecorator extends RequalityDecorator {

  @Override
  public void dispose() {
    if (back != null) {
      back.dispose();
      text.dispose();
    }
  }

  Color back, text;

  @Override
  public void decorate(Object element, final IDecoration decoration) {
    if (!TreeNode.class.isInstance(element)) {
      return;
    }
    TreeNode node = (TreeNode) element;
    if (node.getTreeDB().getRefTargetState(node) > 0)
      Display.getDefault()
          .asyncExec(
              new Runnable() {

                @Override
                public void run() {
                  back = Display.getDefault().getSystemColor(SWT.COLOR_DARK_GRAY);
                  text = Display.getDefault().getSystemColor(SWT.COLOR_WHITE);
                  decoration.setForegroundColor(text);
                  decoration.setBackgroundColor(back);
                  Font old = Display.getDefault().getSystemFont();
                  FontData fd = new FontData(old.getFontData()[0].toString());
                  fd.setStyle(fd.getStyle() | SWT.ITALIC);
                  Font f = new Font(Display.getDefault(), fd);
                  decoration.setFont(f);
                }
              });
    // TODO: change depth if it slows down much
  }

  @Override
  public boolean isLabelProperty(Object element, String property) {
    return true;
  }

  @Override
  public void addListener(ILabelProviderListener listener) {
    // TODO Auto-generated method stub

  }

  @Override
  public void removeListener(ILabelProviderListener listener) {
    // TODO Auto-generated method stub

  }

  @Override
  public Set<String> getRelatedKeys() {
    // TODO Auto-generated method stub
    return Collections.emptySet();
  }
}
